> ## Documentation Index
> Fetch the complete documentation index at: https://docs.tracecat.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Import Table From Csv

> Create a new table by importing a CSV file.



## OpenAPI

````yaml https://platform.tracecat.com/api/openapi.json post /workspaces/{workspace_id}/tables/import
openapi: 3.1.0
info:
  title: Tracecat API
  summary: Tracecat API
  description: The open source AI automation platform for security teams and agents.
  termsOfService: >-
    https://docs.google.com/document/d/e/2PACX-1vQvDe3SoVAPoQc51MgfGCP71IqFYX_rMVEde8zC4qmBCec5f8PLKQRdxa6tsUABT8gWAR9J-EVs2CrQ/pub
  contact:
    name: Tracecat Founders
    email: founders@tracecat.com
  license:
    name: AGPL-3.0
    url: https://www.gnu.org/licenses/agpl-3.0.html
  version: '1'
servers:
  - url: /api
security: []
tags:
  - name: public
    description: Public facing endpoints
  - name: workflows
    description: Workflow management
  - name: actions
    description: Action management
  - name: triggers
    description: Workflow triggers
  - name: secrets
    description: Secret management
  - name: variables
    description: Workspace variable management
paths:
  /workspaces/{workspace_id}/tables/import:
    post:
      tags:
        - tables
      summary: Import Table From Csv
      description: Create a new table by importing a CSV file.
      operationId: tables-import_table_from_csv
      parameters:
        - name: workspace_id
          in: path
          required: true
          schema:
            type: string
            format: uuid
            title: Workspace Id
      requestBody:
        required: true
        content:
          multipart/form-data:
            schema:
              $ref: '#/components/schemas/Body_tables-import_table_from_csv'
      responses:
        '201':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TableImportResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - APIKeyCookie: []
        - ServiceAccountApiKeyBearer: []
components:
  schemas:
    Body_tables-import_table_from_csv:
      properties:
        file:
          type: string
          contentMediaType: application/octet-stream
          title: File
        table_name:
          anyOf:
            - type: string
            - type: 'null'
          title: Table Name
      type: object
      required:
        - file
      title: Body_tables-import_table_from_csv
    TableImportResponse:
      properties:
        table:
          $ref: '#/components/schemas/TableRead'
        rows_inserted:
          type: integer
          title: Rows Inserted
        column_mapping:
          items:
            $ref: '#/components/schemas/InferredColumn'
          type: array
          title: Column Mapping
      type: object
      required:
        - table
        - rows_inserted
        - column_mapping
      title: TableImportResponse
      description: Response model for importing a table from CSV.
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    TableRead:
      properties:
        id:
          type: string
          format: uuid
          title: Id
        name:
          type: string
          title: Name
        columns:
          items:
            $ref: '#/components/schemas/TableColumnRead'
          type: array
          title: Columns
      type: object
      required:
        - id
        - name
        - columns
      title: TableRead
      description: Read model for a table.
    InferredColumn:
      properties:
        csv_header:
          type: string
          title: Csv Header
          description: Original column header in the CSV file
        field_name:
          type: string
          title: Field Name
          description: Column name created in Tracecat
        field_type:
          $ref: '#/components/schemas/SqlType'
          description: Inferred SQL type for the column
      type: object
      required:
        - csv_header
        - field_name
        - field_type
      title: InferredColumn
      description: Inferred column mapping between CSV headers and table columns.
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
        ctx:
          type: object
          title: Context
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    TableColumnRead:
      properties:
        id:
          type: string
          format: uuid
          title: Id
        name:
          type: string
          title: Name
        type:
          $ref: '#/components/schemas/SqlType'
        nullable:
          type: boolean
          title: Nullable
          default: true
        default:
          anyOf:
            - {}
            - type: 'null'
          title: Default
        is_index:
          type: boolean
          title: Is Index
          default: false
        options:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Options
      type: object
      required:
        - id
        - name
        - type
      title: TableColumnRead
      description: Definition for a table column.
    SqlType:
      type: string
      enum:
        - TEXT
        - INTEGER
        - NUMERIC
        - DATE
        - BOOLEAN
        - TIMESTAMPTZ
        - JSONB
        - SELECT
        - MULTI_SELECT
      title: SqlType
      description: Supported SQL types.
  securitySchemes:
    APIKeyCookie:
      type: apiKey
      in: cookie
      name: fastapiusersauth
    ServiceAccountApiKeyBearer:
      type: http
      description: Tracecat service account API key.
      scheme: bearer

````